import pygame,os,random


global JUST_VISUAL, VISUAL_AND_AUDIO, JUST_VISUAL_CONT, PT3BLUE, PT3GREEN, PT3VIOLET
JUST_VISUAL = 1
VISUAL_AND_AUDIO = 2
JUST_VISUAL_CONT = 3
PT3BLUE = 1
PT3GREEN = 2
PT3VIOLET = 3
debug_pt3 = False


class PrimaryTaskManager:
    
    taskType = 100
    car_sound = ""
    telephone_sound = ""
    piano_sound = ""
    debug = False
    objectAlive = [False , False , False , False , False]
    aliveObjects=0
    objectPositions=[[0,0],[0,0],[0,0],[0,0],[0,0]]
    objectLifetimes=[0,0,0,0,0]
    objectTypes=[0,0,0,0,0]
    screenwidth = 0
    screenheight = 0
    symbolsize = 0
    creationPercentageWhenObjects = 0
    survivalPercentageInRound = 0
    maxObjectsAmount = 5
    hitboxbonus = 0
    
    botLogFile = ""
    userLogFile = ""
    
    def __init__(self,taskTypePar,folderPar,debugPar,screenwidthPar,screenheightPar,symbolsizePar,creationPercentagePar,survivalPercentagePar,hitboxbonusPar,maxObjectsPt3Par):
        self.taskType = taskTypePar
        self.debug = debugPar
        self.screenwidth = screenwidthPar
        self.screenheight = screenheightPar
        self.symbolsize = symbolsizePar
        self.creationPercentageWhenObjects = creationPercentagePar
        self.survivalPercentageInRound = survivalPercentagePar
        self.hitboxbonus = hitboxbonusPar
        os.makedirs(folderPar)
        self.botLogFile = open(folderPar + "/botLog.txt",'w')
        self.userLogFile = open(folderPar + "/userLog.txt",'w')
        
        if taskTypePar == VISUAL_AND_AUDIO:
            self.car_sound = pygame.mixer.Sound("res/19025__han1__car-start-and-drive.ogg")
            self.telephone_sound = pygame.mixer.Sound("res/15826__transitking__telephonering.ogg")
            self.piano_sound = pygame.mixer.Sound("res/piano.ogg")
        elif taskTypePar == JUST_VISUAL_CONT:
            self.maxObjectsAmount = maxObjectsPt3Par
            for i1 in range(4,self.maxObjectsAmount):
                self.objectPositions.append([0,0])
                self.objectTypes.append([0,0])
                self.objectAlive.append(False)
            if self.debug: print "pritaskmanager now has " + str(len(self.objectPositions)) + " object positions"
    
    
    def closeTxtFiles(self):
        self.userLogFile.write("EOF")
        self.botLogFile.write("EOF")        
        self.userLogFile.close()
        self.botLogFile.close()
 
    
    def getNumberOfAliveObjects(self):
        return self.aliveObjects
    
    
    def getObjectPosition(self,objectNr):
        return self.objectPositions[objectNr]
    
    
    def getObjectType(self,objectNr):
        return self.objectTypes[objectNr]
    
    
    def findOutIfObjectIsAlive(self,objectNr):
        return self.objectAlive[objectNr]
    
    def rawWriteBotLog(self,string):
        self.botLogFile.write(string)
        if self.debug:
            print "PTM raw Writing to BotEvents from Self: " + string
    
    
    def writeBotEventFromSec(self,time,type_int):
        tempStr = str(time) + "\n" + str(type_int) + "\n-1\n-1\n"
        if self.debug:
            print "PTM Writing to BotEvents from Sec: " + tempStr
        self.botLogFile.write(tempStr)
        
    def writeUserEvent(self,time,type_int):
        tempStr = str(time) + "\n" + str(type_int) + "\n"
        if self.debug:
            print "PTM Writing to UserEvents: " + tempStr
        self.userLogFile.write(tempStr)
        
        
    def checkSingleDimensionCollision(self, object1coord, object1width, object2coord, object2width):
        tempResult = False
        if object2coord == object1coord:
            tempResult = True
        elif object2coord > object1coord:
            if object2coord < object1coord + object1width:
                tempResult = True
        else:
            if object1coord < object2coord + object2width:
                tempResult = True
            
        return tempResult
  
  
    # returns true if there is a collision, and returns number of object with which there is a collision
    def checkAreaCollision(self,leftAndTopCoordOfParItem, parItemWidth):
        totalCollision = False
        i8 = 0
        parItemXcoord = leftAndTopCoordOfParItem[0]
        parItemYcoord = leftAndTopCoordOfParItem[1]
        while (not totalCollision) and (i8 < self.maxObjectsAmount):
            if self.objectAlive[i8]:
                tempXcoord = self.objectPositions[i8][0]
                tempYcoord = self.objectPositions[i8][1]
                xCollision = self.checkSingleDimensionCollision(parItemXcoord, parItemWidth, tempXcoord, 50)
                yCollision = self.checkSingleDimensionCollision(parItemYcoord, parItemWidth, tempYcoord, 50)
                
                #if collision in both dimensions, true collision found
                if xCollision and yCollision:
                    totalCollision = True
            
            i8 = i8 +1
        i8 = i8 -1
        return [totalCollision,i8]
     
     
     
    # for pt3: fill with objects
    # returns color with most objects
    def fillWithObjects(self,timeNow):
        violetcounter = 0
        greencounter = 0
        bluecounter = 0
        for i2s in range(0,self.maxObjectsAmount):
            self.killObject(i2s)
        
        if debug_pt3: print "starting to create objects "
        
        for i3s in range(0,self.maxObjectsAmount):
            if self.createNewItem(i3s):
                if debug_pt3: print str(i3s) + "new item " + str(i3s) + " has been created from fillwithobjects"
                    
        for i4s in range(0,self.maxObjectsAmount):
            objectType = self.objectTypes[i4s]
            if objectType == 1 or objectType == 2 or objectType == 3:
                bluecounter = bluecounter + 1
            elif objectType == 4 or objectType == 5 or objectType == 6:
                greencounter = greencounter + 1
            elif objectType == 7 or objectType == 8 or objectType == 9:
                violetcounter = violetcounter + 1
                
        maxNumber = max(bluecounter,greencounter,violetcounter)
        domColourList = []
        if bluecounter == maxNumber:
            domColourList.append(PT3BLUE)
        if greencounter == maxNumber:
            domColourList.append(PT3GREEN)
        if violetcounter == maxNumber:
            domColourList.append(PT3VIOLET)
            
        amountOfDomColours = len(domColourList)  
            
        if amountOfDomColours == 1:
            return [domColourList[0],maxNumber]
        elif amountOfDomColours < 4 and amountOfDomColours > 1:
            tempRand = random.randint(1,amountOfDomColours)
            tempDomColour = domColourList[tempRand-1]
            return [tempDomColour,maxNumber]
        else:
            print "error at computing pt3 colour with maximum number"
            return [999,maxNumber]
                
        
        
        
        
    # returns true if something has been hit    
    def mouseButtonClick(self,mousepos,pt3lastKeyPar):
        tempXPos = mousepos[0]
        tempYPos = mousepos[1]
        resultObjectNumber = 999
        tempResult = False
        if debug_pt3: print str(tempXPos) + "/" + str(tempYPos)
        
        if tempXPos >= self.screenwidth:
            if debug_pt3: print "mousepress outside of area"
        else:
            tempXPos = tempXPos - self.hitboxbonus
            tempYPos = tempYPos - self.hitboxbonus
            
            if tempXPos < 0:
                tempXPos = 0
            if tempYPos < 0:
                tempYPos = 0
            
            tempResult2 = self.checkAreaCollision([tempXPos,tempYPos], self.hitboxbonus*2)
            if tempResult2[0]:
                if debug_pt3: print "hit at " + str(tempResult2[1])
                resultObjectNumber = tempResult2[1]
                if self.objectTypes[resultObjectNumber] == pt3lastKeyPar:
                    if debug_pt3: print "TRUE hit at " + str(tempResult2[1])
                    tempResult = True
                    self.killObject(resultObjectNumber)
        return tempResult
    
    
    def killObject(self,objectNumber):
        if self.objectAlive[objectNumber]:
            self.objectAlive[objectNumber] = False
            self.aliveObjects = self.aliveObjects - 1
        else:
            if debug_pt3: print "error when trying to kill object no " + str(objectNumber)
        
    # checks all existing items if one of them will be deleted and counts up their lifetime
    # for primary task 1 and 2
    def checkOldItemDeletion(self):
        changes = False
        #check all alive objects if they survive
        for i in range(0,self.maxObjectsAmount):
            if self.objectAlive[i]:
                #object has birthday!
                tempObjectLifetime = self.objectLifetimes[i]
                tempObjectLifetime = tempObjectLifetime + 1
                self.objectLifetimes[i] = tempObjectLifetime  
                if self.debug: print "Object number " + str(i) + " turns " + str(tempObjectLifetime) + " rounds old"
                
                #if so, object dies
                gigaDiceRoll = random.randint(0, 100)
                if self.survivalPercentageInRound[tempObjectLifetime] <= gigaDiceRoll:
                    self.objectAlive[i] = False
                    self.aliveObjects = self.aliveObjects -1
                    changes = True
                    if self.debug: print "Object number " + str(i) + " dies because of dice roll: " + str(gigaDiceRoll) 
        return changes
        
    
    # creates a new item
    # for all primary tasks
    def createNewItem(self,timeNow):
        if debug_pt3: print str(timeNow) + "trying to create new item"
        changes = True
        alreadyCreated = False
        
        #search for a slot without alive object and create if you have not already
        for i1 in range(0,self.maxObjectsAmount):
            if (not self.objectAlive[i1]) and (not alreadyCreated):
                if debug_pt3: print str(timeNow) + "trying to create new item at " + str(i1) + ", entered if"
                self.aliveObjects = self.aliveObjects +1
                collisionFree = False
                newXcoord = 0
                newYcoord = 0
                newObjectsType = random.randint(1,9)
                self.objectTypes[i1] = newObjectsType
                    
                
                #generate random coordinates until new coords are found that do not cause collision
                while not collisionFree:
                    if debug_pt3: print str(timeNow) + "trying to find collision free coords"
                    collisionFree = True
                    newXcoord = random.randint(0, self.screenwidth - self.symbolsize)
                    newYcoord = random.randint(0, self.screenheight - self.symbolsize)
                    
                    # check if new object collides with existing
                    collisionFree = not self.checkAreaCollision([newXcoord,newYcoord], 50)[0]
                  
                
                if debug_pt3: print str(timeNow) + "found collision free coords"  
                # set object alive now because collisions have been checked
                self.objectAlive[i1] = True
                              
                # play sounds if needed                
                if self.taskType == VISUAL_AND_AUDIO:
                    if ((newObjectsType == 1) or (newObjectsType == 4) or (newObjectsType == 7)):
                        self.car_sound.play(0,0,0)
                        if self.debug: print "SOUND car at " + str(timeNow) + " with object number " + str(i1) + " with type " + str(newObjectsType)
                    elif((newObjectsType == 2) or (newObjectsType == 5) or (newObjectsType == 8)):
                        self.telephone_sound.play(0,0,0)
                        if self.debug: print "SOUND tel at " + str(timeNow) + " with object number " + str(i1) + " with type " + str(newObjectsType)
                    elif((newObjectsType == 3) or (newObjectsType == 6) or (newObjectsType == 9)):
                        self.piano_sound.play(0,0,0)
                        if self.debug: print "SOUND piano at " + str(timeNow) + " with object number " + str(i1) + " with type " + str(newObjectsType)
                    else:
                        print "ERROR: new objects type is " + str(newObjectsType) + " and this shouldnt be the case!"
                
                # write new values into variables
                self.objectPositions[i1][0] = newXcoord
                self.objectPositions[i1][1] = newYcoord
                if self.taskType ==1 or self.taskType == 2:
                    self.objectLifetimes[i1] = -1
                    self.rawWriteBotLog(str(timeNow) + "\n" + str(self.objectTypes[i1]) + "\n" + str(newXcoord) + "\n" + str(newYcoord) + "\n")
                if self.debug: print "Created object nr " + str(i1) + " at " + str(timeNow) + ", type " + str(self.objectTypes[i1]) + ", x:" + str(newXcoord) + ", y:" + str(newYcoord)
                alreadyCreated = True
        return changes
    
       
    # checks if a new item should be created 
    # for primary task 1 and 2
    def checkNewItemCreation(self,timeNow):
        changes = False
    
        #maybe create new object, write to bot text file
        if self.aliveObjects < 5:
            if self.debug: print "alive objects is " + str(self.aliveObjects)
            megaDiceRoll = random.randint(0, 100)
            if self.debug: print "Maybe new Object? rolling " + str(megaDiceRoll) + " against a predefined chance of " + str(self.creationPercentageWhenObjects[self.aliveObjects])
            
            #if diceroll is higher than perc, no new item
            if self.creationPercentageWhenObjects[self.aliveObjects] >= megaDiceRoll:
                changes = self.createNewItem(timeNow)
        return changes