import random, SerialManager, re,Util

global TASK_1, TASK_2, NO_TASK, START_COLOUR, RED, GREEN, BLUE, TASK_2_RELEVANT_LIGHT_NR
NO_TASK = 0
TASK_1 = 1
TASK_2 = 2
RED = 6
GREEN = 0
BLUE = 2
START_COLOUR = BLUE
TASK_2_RELEVANT_LIGHT_NR = 4

class SecondaryTaskManager:
    
    taskType = 100
    lightStates = [START_COLOUR,START_COLOUR,START_COLOUR,START_COLOUR,START_COLOUR]                            #main, coll1, coll2, etc
    lightLifetimes = [100,random.randint(0,5),random.randint(0,5),random.randint(0,5),random.randint(0,5)]      #main (is not used), coll1, coll2, etc
    serialManager = SerialManager.SerialManager(False)
    debug = False
    debug_input = False
    changePercentageInRound = []
    lightness = 64
    lastLineAmount = 0
    secChangeBlockingRoundAmount = 0
    roundAmountSinceLastRealChange = 100
    
    def __init__(self,secTaskTypePar,portName,changePercentagePar, debugPar, lightnessPar, debugInputPar, secChangeBlockingRoundAmountPar):      
        self.taskType = secTaskTypePar
        self.debug_input = debugInputPar
        self.serialManager = SerialManager.SerialManager(debugInputPar)
        self.serialManager.setPort(portName)
        self.serialManager.start()
        self.changePercentageInRound = changePercentagePar
        self.debug = debugPar
        self.lightness = lightnessPar
        self.secChangeBlockingRoundAmount = secChangeBlockingRoundAmountPar
        if self.debug: print "SecTaskManager initialized"
        
    def close(self):
        self.lightness=0
        self.updateLights()
        self.serialManager.closeSerial()
        
    
    # reads data from lightstates and writes it to Ambient Presence Indicator via serialManager
    def updateLights(self):
        #change main and colleague lights
        for i in range(0,5):
            self.serialManager.write(i)
            self.serialManager.write(self.lightStates[i])
            self.serialManager.write(self.lightness) 
            
    # changes the main light depending on which direction the main light has been turned        
    def changeMainLight(self,posDir):
        if posDir:
            if self.lightStates[0] == RED:
                self.lightStates[0] = GREEN
                return GREEN
            elif self.lightStates[0] == GREEN:
                self.lightStates[0] = BLUE
                return BLUE
            elif self.lightStates[0] == BLUE:
                self.lightStates[0] = RED
                return RED
        else:
            if self.lightStates[0] == RED:
                self.lightStates[0] = BLUE
                return BLUE
            elif self.lightStates[0] == GREEN:
                self.lightStates[0] = RED
                return RED
            elif self.lightStates[0] == BLUE:
                self.lightStates[0] = GREEN
                return GREEN

    
    # searches a new colour for a certain colleague light and sets the value in the variable
    def changeColleagueLight(self,lightNr):
        if self.debug: print "light number " + str(lightNr) + " is getting changed"
        oldColour = self.lightStates[lightNr]
        oldDominantColour = 99
        
        foundGoodColour = False
        newColour = 0
        
        
        while not foundGoodColour:
            
            if self.debug: print "Searching for new colour"
            
            foundGoodColour = True
            sameColour = False
            
            redCount = 0
            greenCount = 0
            blueCount = 0
        
            #roll random new colour
            newColourRand = random.randint(0,2)
            
            if newColourRand == 0:
                newColour = RED
                redCount = 1
            elif newColourRand == 1:
                newColour = GREEN
                greenCount = 1
            elif newColourRand == 2:
                newColour = BLUE
                blueCount = 1

            #check if new colour is old colour
            if newColour == oldColour:
                sameColour = True
                foundGoodColour = False
        
            #check if there are 2 colour couples
            if (not sameColour) and self.taskType == TASK_1:
                
                coloursWithTwoPanels = 0
                
                for i in range(1,5):
                    if i != lightNr:
                        if self.lightStates[i] == RED: redCount = redCount +1
                        elif self.lightStates[i] == GREEN: greenCount = greenCount +1
                        elif self.lightStates[i] == BLUE: blueCount = blueCount +1
                    
                if redCount     == 2: coloursWithTwoPanels = coloursWithTwoPanels +1
                if greenCount   == 2: coloursWithTwoPanels = coloursWithTwoPanels +1
                if blueCount    == 2: coloursWithTwoPanels = coloursWithTwoPanels +1
                
                if coloursWithTwoPanels == 2: foundGoodColour = False
        
        if self.taskType == 1:
            oldDominantColour = Util.computeDominantColour(self.lightStates)
                
        self.lightStates[lightNr] = newColour
        self.lightLifetimes[lightNr] = 0
        
        
        #update roundAmountSinceLastRealChange if this is a relevant change for the task
        if self.taskType == 1:
            if Util.computeDominantColour(self.lightStates) != oldDominantColour:
                self.roundAmountSinceLastRealChange = 0
        else:
            if lightNr == TASK_2_RELEVANT_LIGHT_NR:
                self.roundAmountSinceLastRealChange = 0  
        
        return newColour

    # find out if colleague light i should be blocked because there has been a significant change recently
    # and user has still time to react to this change
    def isThisABlockedLight(self,i):
        if self.taskType ==1:
            #find out if light nr i is of relevant color
            if self.lightStates[i] == Util.computeDominantColour(self.lightStates):
                
                amountOfDominantColourLights = 0
                
                for j in range(1,5):
                    if self.lightStates[i] == self.lightStates[j]:
                        amountOfDominantColourLights = amountOfDominantColourLights +1
                
                if amountOfDominantColourLights == 2:
                    return True
                else:                
                    False
            else:
                return False
        else:
            if i == TASK_2_RELEVANT_LIGHT_NR:
                return True
            else:
                return False

    # check if a colleague lights colour should be changed
    # return code of new event, or 999 if there is no new event
    def checkChangeCreation(self,timeNow):
        
        self.roundAmountSinceLastRealChange = self.roundAmountSinceLastRealChange + 1
        
        changes = False
        for i in range(1,5):
            #light has birthday!
            tempLightLifetime = self.lightLifetimes[i]
            tempLightLifetime = tempLightLifetime + 1
            self.lightLifetimes[i] = tempLightLifetime  
            if self.debug: print "light number " + str(i) + " turns " + str(tempLightLifetime) + " rounds old"
            
            if changes == False:
                
                #if so, light changes
                gigaDiceRoll = random.randint(0, 100)
                if self.changePercentageInRound[tempLightLifetime] >= gigaDiceRoll:
                    
                    #find out if it is relevant for blocking or blocking is already over
                    if ((self.roundAmountSinceLastRealChange > self.secChangeBlockingRoundAmount) or (not self.isThisABlockedLight(i))):
                        newColour = self.changeColleagueLight(i)
                        changes = True
                        result = (100*i) + newColour
                        if self.debug: print "result ist " + str(result)
                        return result
        return 999
    
    # check if there is new user input data in secondary Manager (lineRead)
    # by checking secondary Manager (line Amount)
    # returns new colour, or 100 if no change
    def checkForUserInput(self):
        #print "about to read"
        
        if self.lastLineAmount < self.serialManager.getLineAmount():
        
            self.lastLineAmount = self.serialManager.getLineAmount()
        
            data = self.serialManager.getLastLine()
        
            if self.debug_input: print "data is " + str(data)
        
            if data == 1: return self.changeMainLight(True)
            elif data == -1: return self.changeMainLight(False)
        
        return 100